// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from r2r_spl_test_interfaces:msg/ArrayTypes.idl
// generated code does not contain a copyright notice

#ifndef R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__STRUCT_HPP_
#define R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__r2r_spl_test_interfaces__msg__ArrayTypes __attribute__((deprecated))
#else
# define DEPRECATED__r2r_spl_test_interfaces__msg__ArrayTypes __declspec(deprecated)
#endif

namespace r2r_spl_test_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ArrayTypes_
{
  using Type = ArrayTypes_<ContainerAllocator>;

  explicit ArrayTypes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<int8_t, 3>::iterator, int8_t>(this->data_int8_static.begin(), this->data_int8_static.end(), 0);
      std::fill<typename std::array<bool, 2>::iterator, bool>(this->data_bool_static.begin(), this->data_bool_static.end(), false);
      this->data_string = "";
      this->data_string_bounded = "";
      this->data_wstring = u"";
      this->data_wstring_bounded = u"";
    }
  }

  explicit ArrayTypes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : data_int8_static(_alloc),
    data_bool_static(_alloc),
    data_string(_alloc),
    data_string_bounded(_alloc),
    data_wstring(_alloc),
    data_wstring_bounded(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<int8_t, 3>::iterator, int8_t>(this->data_int8_static.begin(), this->data_int8_static.end(), 0);
      std::fill<typename std::array<bool, 2>::iterator, bool>(this->data_bool_static.begin(), this->data_bool_static.end(), false);
      this->data_string = "";
      this->data_string_bounded = "";
      this->data_wstring = u"";
      this->data_wstring_bounded = u"";
    }
  }

  // field types and members
  using _data_int8_static_type =
    std::array<int8_t, 3>;
  _data_int8_static_type data_int8_static;
  using _data_bool_static_type =
    std::array<bool, 2>;
  _data_bool_static_type data_bool_static;
  using _data_int8_unbounded_dynamic_type =
    std::vector<int8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int8_t>>;
  _data_int8_unbounded_dynamic_type data_int8_unbounded_dynamic;
  using _data_bool_unbounded_dynamic_type =
    std::vector<bool, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>>;
  _data_bool_unbounded_dynamic_type data_bool_unbounded_dynamic;
  using _data_int8_bounded_dynamic_type =
    rosidl_runtime_cpp::BoundedVector<int8_t, 3, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int8_t>>;
  _data_int8_bounded_dynamic_type data_int8_bounded_dynamic;
  using _data_bool_bounded_dynamic_type =
    rosidl_runtime_cpp::BoundedVector<bool, 2, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>>;
  _data_bool_bounded_dynamic_type data_bool_bounded_dynamic;
  using _data_string_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_string_type data_string;
  using _data_string_bounded_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_string_bounded_type data_string_bounded;
  using _data_wstring_type =
    std::basic_string<char16_t, std::char_traits<char16_t>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char16_t>>;
  _data_wstring_type data_wstring;
  using _data_wstring_bounded_type =
    std::basic_string<char16_t, std::char_traits<char16_t>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char16_t>>;
  _data_wstring_bounded_type data_wstring_bounded;

  // setters for named parameter idiom
  Type & set__data_int8_static(
    const std::array<int8_t, 3> & _arg)
  {
    this->data_int8_static = _arg;
    return *this;
  }
  Type & set__data_bool_static(
    const std::array<bool, 2> & _arg)
  {
    this->data_bool_static = _arg;
    return *this;
  }
  Type & set__data_int8_unbounded_dynamic(
    const std::vector<int8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int8_t>> & _arg)
  {
    this->data_int8_unbounded_dynamic = _arg;
    return *this;
  }
  Type & set__data_bool_unbounded_dynamic(
    const std::vector<bool, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>> & _arg)
  {
    this->data_bool_unbounded_dynamic = _arg;
    return *this;
  }
  Type & set__data_int8_bounded_dynamic(
    const rosidl_runtime_cpp::BoundedVector<int8_t, 3, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int8_t>> & _arg)
  {
    this->data_int8_bounded_dynamic = _arg;
    return *this;
  }
  Type & set__data_bool_bounded_dynamic(
    const rosidl_runtime_cpp::BoundedVector<bool, 2, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>> & _arg)
  {
    this->data_bool_bounded_dynamic = _arg;
    return *this;
  }
  Type & set__data_string(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data_string = _arg;
    return *this;
  }
  Type & set__data_string_bounded(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data_string_bounded = _arg;
    return *this;
  }
  Type & set__data_wstring(
    const std::basic_string<char16_t, std::char_traits<char16_t>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char16_t>> & _arg)
  {
    this->data_wstring = _arg;
    return *this;
  }
  Type & set__data_wstring_bounded(
    const std::basic_string<char16_t, std::char_traits<char16_t>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char16_t>> & _arg)
  {
    this->data_wstring_bounded = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator> *;
  using ConstRawPtr =
    const r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__r2r_spl_test_interfaces__msg__ArrayTypes
    std::shared_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__r2r_spl_test_interfaces__msg__ArrayTypes
    std::shared_ptr<r2r_spl_test_interfaces::msg::ArrayTypes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ArrayTypes_ & other) const
  {
    if (this->data_int8_static != other.data_int8_static) {
      return false;
    }
    if (this->data_bool_static != other.data_bool_static) {
      return false;
    }
    if (this->data_int8_unbounded_dynamic != other.data_int8_unbounded_dynamic) {
      return false;
    }
    if (this->data_bool_unbounded_dynamic != other.data_bool_unbounded_dynamic) {
      return false;
    }
    if (this->data_int8_bounded_dynamic != other.data_int8_bounded_dynamic) {
      return false;
    }
    if (this->data_bool_bounded_dynamic != other.data_bool_bounded_dynamic) {
      return false;
    }
    if (this->data_string != other.data_string) {
      return false;
    }
    if (this->data_string_bounded != other.data_string_bounded) {
      return false;
    }
    if (this->data_wstring != other.data_wstring) {
      return false;
    }
    if (this->data_wstring_bounded != other.data_wstring_bounded) {
      return false;
    }
    return true;
  }
  bool operator!=(const ArrayTypes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ArrayTypes_

// alias to use template instance with default allocator
using ArrayTypes =
  r2r_spl_test_interfaces::msg::ArrayTypes_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace r2r_spl_test_interfaces

#endif  // R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__STRUCT_HPP_
