// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from r2r_spl_test_interfaces:msg/BasicTypes.idl
// generated code does not contain a copyright notice

#ifndef R2R_SPL_TEST_INTERFACES__MSG__DETAIL__BASIC_TYPES__STRUCT_HPP_
#define R2R_SPL_TEST_INTERFACES__MSG__DETAIL__BASIC_TYPES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__r2r_spl_test_interfaces__msg__BasicTypes __attribute__((deprecated))
#else
# define DEPRECATED__r2r_spl_test_interfaces__msg__BasicTypes __declspec(deprecated)
#endif

namespace r2r_spl_test_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BasicTypes_
{
  using Type = BasicTypes_<ContainerAllocator>;

  explicit BasicTypes_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->val_bool = false;
      this->val_byte = 0;
      this->val_char = 0;
      this->val_float32 = 0.0f;
      this->val_float64 = 0.0;
      this->val_int8 = 0;
      this->val_uint8 = 0;
      this->val_int16 = 0;
      this->val_uint16 = 0;
      this->val_int32 = 0l;
      this->val_uint32 = 0ul;
      this->val_int64 = 0ll;
      this->val_uint64 = 0ull;
    }
  }

  explicit BasicTypes_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->val_bool = false;
      this->val_byte = 0;
      this->val_char = 0;
      this->val_float32 = 0.0f;
      this->val_float64 = 0.0;
      this->val_int8 = 0;
      this->val_uint8 = 0;
      this->val_int16 = 0;
      this->val_uint16 = 0;
      this->val_int32 = 0l;
      this->val_uint32 = 0ul;
      this->val_int64 = 0ll;
      this->val_uint64 = 0ull;
    }
  }

  // field types and members
  using _val_bool_type =
    bool;
  _val_bool_type val_bool;
  using _val_byte_type =
    unsigned char;
  _val_byte_type val_byte;
  using _val_char_type =
    uint8_t;
  _val_char_type val_char;
  using _val_float32_type =
    float;
  _val_float32_type val_float32;
  using _val_float64_type =
    double;
  _val_float64_type val_float64;
  using _val_int8_type =
    int8_t;
  _val_int8_type val_int8;
  using _val_uint8_type =
    uint8_t;
  _val_uint8_type val_uint8;
  using _val_int16_type =
    int16_t;
  _val_int16_type val_int16;
  using _val_uint16_type =
    uint16_t;
  _val_uint16_type val_uint16;
  using _val_int32_type =
    int32_t;
  _val_int32_type val_int32;
  using _val_uint32_type =
    uint32_t;
  _val_uint32_type val_uint32;
  using _val_int64_type =
    int64_t;
  _val_int64_type val_int64;
  using _val_uint64_type =
    uint64_t;
  _val_uint64_type val_uint64;

  // setters for named parameter idiom
  Type & set__val_bool(
    const bool & _arg)
  {
    this->val_bool = _arg;
    return *this;
  }
  Type & set__val_byte(
    const unsigned char & _arg)
  {
    this->val_byte = _arg;
    return *this;
  }
  Type & set__val_char(
    const uint8_t & _arg)
  {
    this->val_char = _arg;
    return *this;
  }
  Type & set__val_float32(
    const float & _arg)
  {
    this->val_float32 = _arg;
    return *this;
  }
  Type & set__val_float64(
    const double & _arg)
  {
    this->val_float64 = _arg;
    return *this;
  }
  Type & set__val_int8(
    const int8_t & _arg)
  {
    this->val_int8 = _arg;
    return *this;
  }
  Type & set__val_uint8(
    const uint8_t & _arg)
  {
    this->val_uint8 = _arg;
    return *this;
  }
  Type & set__val_int16(
    const int16_t & _arg)
  {
    this->val_int16 = _arg;
    return *this;
  }
  Type & set__val_uint16(
    const uint16_t & _arg)
  {
    this->val_uint16 = _arg;
    return *this;
  }
  Type & set__val_int32(
    const int32_t & _arg)
  {
    this->val_int32 = _arg;
    return *this;
  }
  Type & set__val_uint32(
    const uint32_t & _arg)
  {
    this->val_uint32 = _arg;
    return *this;
  }
  Type & set__val_int64(
    const int64_t & _arg)
  {
    this->val_int64 = _arg;
    return *this;
  }
  Type & set__val_uint64(
    const uint64_t & _arg)
  {
    this->val_uint64 = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator> *;
  using ConstRawPtr =
    const r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__r2r_spl_test_interfaces__msg__BasicTypes
    std::shared_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__r2r_spl_test_interfaces__msg__BasicTypes
    std::shared_ptr<r2r_spl_test_interfaces::msg::BasicTypes_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BasicTypes_ & other) const
  {
    if (this->val_bool != other.val_bool) {
      return false;
    }
    if (this->val_byte != other.val_byte) {
      return false;
    }
    if (this->val_char != other.val_char) {
      return false;
    }
    if (this->val_float32 != other.val_float32) {
      return false;
    }
    if (this->val_float64 != other.val_float64) {
      return false;
    }
    if (this->val_int8 != other.val_int8) {
      return false;
    }
    if (this->val_uint8 != other.val_uint8) {
      return false;
    }
    if (this->val_int16 != other.val_int16) {
      return false;
    }
    if (this->val_uint16 != other.val_uint16) {
      return false;
    }
    if (this->val_int32 != other.val_int32) {
      return false;
    }
    if (this->val_uint32 != other.val_uint32) {
      return false;
    }
    if (this->val_int64 != other.val_int64) {
      return false;
    }
    if (this->val_uint64 != other.val_uint64) {
      return false;
    }
    return true;
  }
  bool operator!=(const BasicTypes_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BasicTypes_

// alias to use template instance with default allocator
using BasicTypes =
  r2r_spl_test_interfaces::msg::BasicTypes_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace r2r_spl_test_interfaces

#endif  // R2R_SPL_TEST_INTERFACES__MSG__DETAIL__BASIC_TYPES__STRUCT_HPP_
