// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from r2r_spl_test_interfaces:msg/ArrayTypes.idl
// generated code does not contain a copyright notice

#ifndef R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__STRUCT_H_
#define R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'data_int8_unbounded_dynamic'
// Member 'data_bool_unbounded_dynamic'
// Member 'data_int8_bounded_dynamic'
// Member 'data_bool_bounded_dynamic'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'data_string'
// Member 'data_string_bounded'
#include "rosidl_runtime_c/string.h"
// Member 'data_wstring'
// Member 'data_wstring_bounded'
#include "rosidl_runtime_c/u16string.h"

// constants for array fields with an upper bound
// data_int8_bounded_dynamic
enum
{
  r2r_spl_test_interfaces__msg__ArrayTypes__data_int8_bounded_dynamic__MAX_SIZE = 3
};
// data_bool_bounded_dynamic
enum
{
  r2r_spl_test_interfaces__msg__ArrayTypes__data_bool_bounded_dynamic__MAX_SIZE = 2
};
// data_string_bounded
enum
{
  r2r_spl_test_interfaces__msg__ArrayTypes__data_string_bounded__MAX_STRING_SIZE = 3
};
// data_wstring_bounded
enum
{
  r2r_spl_test_interfaces__msg__ArrayTypes__data_wstring_bounded__MAX_STRING_SIZE = 3
};

/// Struct defined in msg/ArrayTypes in the package r2r_spl_test_interfaces.
typedef struct r2r_spl_test_interfaces__msg__ArrayTypes
{
  /// Test numeric static array (since it uses numpy arrays)
  int8_t data_int8_static[3];
  /// Test non-numeric static array
  bool data_bool_static[2];
  /// Test numeric unbounded array
  rosidl_runtime_c__int8__Sequence data_int8_unbounded_dynamic;
  /// Test non-numeric unbounded array
  rosidl_runtime_c__boolean__Sequence data_bool_unbounded_dynamic;
  /// Test numeric bounded array
  rosidl_runtime_c__int8__Sequence data_int8_bounded_dynamic;
  /// Test non-numeric bounded array
  rosidl_runtime_c__boolean__Sequence data_bool_bounded_dynamic;
  /// Test string
  rosidl_runtime_c__String data_string;
  /// Test bounded string
  rosidl_runtime_c__String data_string_bounded;
  /// Test wstring
  rosidl_runtime_c__U16String data_wstring;
  /// Test bounded wstring
  rosidl_runtime_c__U16String data_wstring_bounded;
} r2r_spl_test_interfaces__msg__ArrayTypes;

// Struct for a sequence of r2r_spl_test_interfaces__msg__ArrayTypes.
typedef struct r2r_spl_test_interfaces__msg__ArrayTypes__Sequence
{
  r2r_spl_test_interfaces__msg__ArrayTypes * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} r2r_spl_test_interfaces__msg__ArrayTypes__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // R2R_SPL_TEST_INTERFACES__MSG__DETAIL__ARRAY_TYPES__STRUCT_H_
